// EditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "updalbum.h"
#include "EditDlg.h"
#include "FTPInfo.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditDlg dialog


CEditDlg::CEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditDlg)
	m_sName = _T("My DAlbum site");
	m_bPassive = TRUE;
	m_sPassword = _T("x@y.com");
	m_sPath = _T("public_html");
	m_nPort = 21;
	m_sUser = _T("anonymous");
	m_sServer = _T("ftp.mysite.com");
	//}}AFX_DATA_INIT
}


void CEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditDlg)
	DDX_Text(pDX, IDC_NAME, m_sName);
	DDX_Check(pDX, IDC_PASSIVE, m_bPassive);
	DDX_Text(pDX, IDC_PASSWORD, m_sPassword);
	DDX_Text(pDX, IDC_PATH, m_sPath);
	DDX_Text(pDX, IDC_PORT, m_nPort);
	DDX_Text(pDX, IDC_USER, m_sUser);
	DDX_Text(pDX, IDC_FTP, m_sServer);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditDlg, CDialog)
	//{{AFX_MSG_MAP(CEditDlg)
	ON_BN_CLICKED(IDC_VERIFY, OnVerify)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditDlg message handlers

void CEditDlg::OnOK() 
{
	UpdateData();

	
	CDialog::OnOK();
}

void CEditDlg::OnVerify() 
{
	CWaitCursor w;

	UpdateData();

	try 
	{
		CInternetSession session(AGENT);
		auto_ptr<CFtpConnection> pFTP(session.GetFtpConnection(  m_sServer, m_sUser, m_sPassword, m_nPort, m_bPassive));
		if (!pFTP->SetCurrentDirectory(m_sPath))
		{
			AfxMessageBox(CString("Unable to set FTP directory to ")+m_sPath,MB_ICONERROR);
			return;
		}
		
		auto_ptr<CInternetFile> pFile(pFTP->OpenFile("version.txt",GENERIC_READ,FTP_TRANSFER_TYPE_ASCII));	
		
		CString s;
		if (pFile->ReadString(s))
		{
			AfxMessageBox("Verification succeeded. DAlbum version is " + s,MB_ICONINFORMATION);
		}
		pFile->Close();
		pFTP->Close();
		
	}
	catch (CException *e)
	{
		CString s = "Error downloading version.txt : ";

		TCHAR buf[600]="Unknown error";
		e->GetErrorMessage(buf,600);
		s+=buf;
		
		AfxMessageBox(s,MB_ICONERROR);
		e->Delete();
		return;
	}
	
	
}
