// FTPInfo.cpp: implementation of the CFTPInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "updalbum.h"
#include "FTPInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CString CFTPInfoArray::GetININame()
{
	TCHAR buf[MAX_PATH]="";
	GetModuleFileName(0,buf,MAX_PATH);
	
	LPTSTR sz=strrchr(buf,'\\');
	if (!sz)
		sz=strrchr(buf,'/');
	if (sz)
		strcpy(sz+1,"updalbum.ini");
	else
		strcpy(buf,"updalbum.ini");
	
	TCHAR buf1[MAX_PATH]="";
	if (!GetFullPathName(buf,MAX_PATH,buf1,0))
		return "updalbum.ini";
	return buf1;
}

BOOL	CFTPInfoArray::LoadINI()
{
	while (GetSize()) RemoveAt(0);

	CString sINI=GetININame();
	for (int nSite=1; ;++nSite)
	{
		CString sSite;
		sSite.Format("Site%d",nSite);
		
		TCHAR buf[4096]="";
		if (!GetPrivateProfileString(sSite,"Server","",buf,4096,sINI))
			break;

		CFTPInfo *p=new CFTPInfo;
		Add(p);
		p->m_sServer=buf;

		if (!GetPrivateProfileString(sSite,"Name",p->m_sServer,buf,4096,sINI))
			break;
		p->m_sName=buf;
			
		GetPrivateProfileString(sSite,"User","",buf,4096,sINI);
		p->m_sUser=buf;
		
		GetPrivateProfileString(sSite,"Password","",buf,4096,sINI);
		p->m_sPassword=buf;
		
		GetPrivateProfileString(sSite,"Path","/",buf,4096,sINI);
		p->m_sPath=buf;
		
		p->m_nPort=GetPrivateProfileInt(sSite,"Port",21,sINI);
		p->m_bPassive=GetPrivateProfileInt(sSite,"Passive",1,sINI);
	}
	return TRUE;	
}

BOOL	CFTPInfoArray::SaveINI()
{
	CString sINI=GetININame();		
r:
	FILE *f=fopen(sINI,"wt");
	if (!f)
	{
		int n=AfxMessageBox(CString("Unable to open file ") + sINI + " for writing. Error: " + strerror(errno),MB_ICONERROR|MB_RETRYCANCEL);
		if (n==IDRETRY)
			goto r;
		return FALSE;
	}

	for (int i=0;i<GetSize();++i)
	{
		CFTPInfo *p=(CFTPInfo *)m_Data[i];
		fprintf(f,"[Site%d]\n",i+1);
		fprintf(f,"Name=%s\n",(LPCTSTR)p->m_sName);
		fprintf(f,"Server=%s\n",(LPCTSTR)p->m_sServer);
		fprintf(f,"Port=%d\n",p->m_nPort);
		fprintf(f,"Passive=%d\n",!!p->m_bPassive);
		fprintf(f,"User=%s\n",(LPCTSTR)p->m_sUser);
		fprintf(f,"Password=%s\n",(LPCTSTR)p->m_sPassword);
		fprintf(f,"Path=%s\n",(LPCTSTR)p->m_sPath);
		fprintf(f,"\n");
	}
	fclose(f);
	return TRUE;
}